From: rhn <gihu.rhn@porcupinefactory.org>
To: notmuch@notmuchmail.org
Cc: rhn <gihu.rhn@porcupinefactory.org>
Subject: [PATCH 2/3] test: Check for replies obeying lifetime guarantees
Date: Mon, 17 Dec 2018 17:57:47 +0000 [thread overview]
Message-ID: <20181217175748.10814-3-gihu.rhn@porcupinefactory.org> (raw)
In-Reply-To: <20181217175748.10814-1-gihu.rhn@porcupinefactory.org>
The test attempts to check that a message coming from a thread outlives its messages list and gets destroyed together with the thread.
---
test/T720-lib-lifetime.sh | 83 +++++++++++++++++++++++++++++++++++++++
1 file changed, 83 insertions(+)
create mode 100755 test/T720-lib-lifetime.sh
diff --git a/test/T720-lib-lifetime.sh b/test/T720-lib-lifetime.sh
new file mode 100755
index 00000000..3d94d4df
--- /dev/null
+++ b/test/T720-lib-lifetime.sh
@@ -0,0 +1,83 @@
+#!/usr/bin/env bash
+#
+# Copyright (c) 2018 rhn
+#
+
+
+test_description="Lifetime constraints for library"
+
+. $(dirname "$0")/test-lib.sh || exit 1
+
+add_email_corpus threading
+
+test_begin_subtest "building database"
+test_expect_success "NOTMUCH_NEW"
+
+test_begin_subtest "Message outlives parent Messages from replies"
+
+test_C ${MAIL_DIR} <<'EOF'
+#include <stdio.h>
+#include <stdlib.h>
+#include <notmuch.h>
+int main (int argc, char** argv)
+{
+ notmuch_database_t *db;
+ notmuch_status_t stat;
+ stat = notmuch_database_open (argv[1], NOTMUCH_DATABASE_MODE_READ_ONLY, &db);
+ if (stat != NOTMUCH_STATUS_SUCCESS) {
+ fprintf (stderr, "error opening database: %d\n", stat);
+ exit (1);
+ }
+
+ notmuch_query_t *query = notmuch_query_create (db, "id:B00-root@example.org");
+ notmuch_threads_t *threads;
+
+ stat = notmuch_query_search_threads (query, &threads);
+ if (stat != NOTMUCH_STATUS_SUCCESS) {
+ fprintf (stderr, "error querying threads: %d\n", stat);
+ exit (1);
+ }
+
+ if (!notmuch_threads_valid (threads)) {
+ fprintf (stderr, "invalid threads");
+ exit (1);
+ }
+
+ notmuch_thread_t *thread = notmuch_threads_get (threads);
+ notmuch_messages_t *messages = notmuch_thread_get_messages (thread);
+
+ if (!notmuch_messages_valid (messages)) {
+ fprintf (stderr, "invalid messages");
+ exit (1);
+ }
+
+ notmuch_message_t *message = notmuch_messages_get (messages);
+ notmuch_messages_t *replies = notmuch_message_get_replies (message);
+ if (!notmuch_messages_valid (replies)) {
+ fprintf (stderr, "invalid replies");
+ exit (1);
+ }
+
+ notmuch_message_t *reply = notmuch_messages_get (replies);
+
+ notmuch_messages_destroy (replies); // the reply should not get destroyed here
+ notmuch_message_destroy (message);
+ notmuch_messages_destroy (messages); // nor here
+
+ const char *mid = notmuch_message_get_message_id (reply); // should not crash when accessing
+ fprintf (stdout, "Reply id: %s\n", mid);
+ notmuch_message_destroy (reply);
+ notmuch_thread_destroy (thread); // this destroys the reply
+ notmuch_threads_destroy (threads);
+ notmuch_query_destroy (query);
+ notmuch_database_destroy (db);
+}
+EOF
+cat <<'EOF' >EXPECTED
+== stdout ==
+Reply id: B01-child@example.org
+== stderr ==
+EOF
+test_expect_equal_file EXPECTED OUTPUT
+
+test_done
--
2.17.2
next prev parent reply other threads:[~2018-12-17 18:06 UTC|newest]
Thread overview: 7+ messages / expand[flat|nested] mbox.gz Atom feed top
2018-12-17 17:57 [PATCH 0/3] API: add notes on lifetimes rhn
2018-12-17 17:57 ` [PATCH 1/3] lib: Explicitly state when replies will be destroyed rhn
2018-12-17 17:57 ` rhn [this message]
2018-12-17 17:57 ` [PATCH 3/3] docs: Use correct call to notmuch_query_search_threads in usage example rhn
2019-01-26 1:14 ` David Bremner
2018-12-17 20:05 ` [PATCH 0/3] API: add notes on lifetimes Tomi Ollila
2018-12-23 10:08 ` rhn
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
List information: https://notmuchmail.org/
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=20181217175748.10814-3-gihu.rhn@porcupinefactory.org \
--to=gihu.rhn@porcupinefactory.org \
--cc=notmuch@notmuchmail.org \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
Code repositories for project(s) associated with this public inbox
https://yhetil.org/notmuch.git/
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for read-only IMAP folder(s) and NNTP newsgroup(s).